//+------------------------------------------------------------------+
//|                                             BBands_Stop_v3.0.mq4 |
//|                        Copyright  2006-13, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-13, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 RoyalBlue
#property indicator_color2 Coral
#property indicator_color3 RoyalBlue
#property indicator_color4 Coral
#property indicator_color5 RoyalBlue
#property indicator_color6 Coral
#property indicator_width3 0
#property indicator_width4 0

  
//---- input parameters

//extern int     Nbars           =     500;
extern int     TimeFrame            =     0;    // TimeFrame in min
extern int     UpBandPrice          =     0;    // Upper Band Price(ex.2 for High)     
extern int     LoBandPrice          =     0;    // Lower Band Price(ex.3 for Low) 
extern int     MA_Length            =     6;    // Bollinger Bands Period
extern int     MA_Mode              =     0;    // Mode of Moving Average  
extern double  Deviation            =     1;    // Deviation
extern int     DeviationLength      =     20;    // Period of Standard Deviation
extern double  MoneyRisk            =     0.5;    // Offset Factor
extern int     SignalMode           =     1;    // SignalMode: Display signals mode: 0-only Stops,1-Signals & Stops,2-only Signals
extern int     LineMode             =     1;    // Display line mode: 0-no,1-yes  
extern string  alerts               = "--- Alerts & Emails ---";
extern int     AlertMode            =     0;
extern int     SoundsNumber         =     5;    //Number of sounds after Signal
extern int     SoundsPause          =     5;    //Pause in sec between sounds 
extern string  UpSound              = "alert.wav";
extern string  DnSound              = "alert2.wav";
extern int     EmailMode            =     0;    //0-on,1-off   
extern int     EmailsNumber         =     0;    //0-on,1-off


//---- indicator buffers
double UpTrend[];
double DnTrend[];
double UpSignal[];
double DnSignal[];
double UpLine[];
double DnLine[];
double trend[];


double   upband1[2], dnband1[2], upband2[2], dnband2[2];
datetime prevtime, preTime, ptime;
string   short_name, TF, IndicatorName, prevmess, prevemail;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   if(TimeFrame <= Period()) TimeFrame = Period();
   TF = tf(TimeFrame);
   
//---- 
   IndicatorBuffers(7);
   SetIndexBuffer(0, UpTrend); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1, DnTrend); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,UpSignal); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,108);
   SetIndexBuffer(3,DnSignal); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,  UpLine); SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(5,  DnLine); SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(6,   trend);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- 
   IndicatorName = WindowExpertName(); 
   short_name    = IndicatorName+"["+TF+"]("+UpBandPrice+","+LoBandPrice+","+MA_Length+","+DeviationLength+","+DoubleToStr(Deviation,2)+","+DoubleToStr(MoneyRisk,2)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend Stop");
   SetIndexLabel(1,"DnTrend Stop");
   SetIndexLabel(2,"UpTrend Signal");
   SetIndexLabel(3,"DnTrend Signal");
   SetIndexLabel(4,"UpTrend Line");
   SetIndexLabel(5,"DnTrend Line");
//----
   SetIndexDrawBegin(0,MA_Length+DeviationLength);
   SetIndexDrawBegin(1,MA_Length+DeviationLength);
   SetIndexDrawBegin(2,MA_Length+DeviationLength);
   SetIndexDrawBegin(3,MA_Length+DeviationLength);
   SetIndexDrawBegin(4,MA_Length+DeviationLength);
   SetIndexDrawBegin(5,MA_Length+DeviationLength);
//----
   return(0);
}

//+------------------------------------------------------------------+
//| BBands_Stop_v3.0                                                 |
//+------------------------------------------------------------------+
int start()
{
   int shift,limit, counted_bars=IndicatorCounted();
      
   if(counted_bars > 0) limit = Bars - counted_bars - 1;
   if(counted_bars < 0) return(0);
   if(counted_bars < 1)
   { 
   limit = Bars-1;   
      for(int i=0;i<limit;i++)
      { 
      UpTrend[i]  = EMPTY_VALUE;
      DnTrend[i]  = EMPTY_VALUE;
      UpSignal[i] = EMPTY_VALUE;
      DnSignal[i] = EMPTY_VALUE;
      UpLine[i]   = EMPTY_VALUE;
      DnLine[i]   = EMPTY_VALUE;
      }
   }   
   
   
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period());   
      
      for(shift = 0;shift < limit;shift++) 
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      
      
      UpTrend[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,MA_Length,MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,0,y);
                                      
      DnTrend[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice,MA_Length,MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,1,y);      
      
         if(SignalMode > 0)
         {         
         UpSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice, MA_Length, MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                   "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,2,y);      
         DnSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice, MA_Length, MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                   "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,3,y);      
         }       
      
         if(LineMode > 0)
         {
         UpLine[shift]   = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice, MA_Length, MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                   "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,4,y);      
         DnLine[shift]   = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice, MA_Length, MA_Mode,Deviation,DeviationLength,MoneyRisk,SignalMode,LineMode,
                                   "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,5,y);      
         }
     }  
	
	return(0);
	}
	else
	{
      for(shift=limit;shift>=0;shift--) 
      {	
         if(prevtime != Time[shift])
         {
         upband1[1] = upband1[0];
         dnband1[1] = dnband1[0];
         upband2[1] = upband2[0];
         dnband2[1] = dnband2[0];
         prevtime   = Time[shift];
         }
   
      
      double upMA = iMA(NULL,0,MA_Length,0,MA_Mode,UpBandPrice,shift);
      double dnMA = iMA(NULL,0,MA_Length,0,MA_Mode,LoBandPrice,shift);
	
      double upStdDev = iStdDev(NULL,0,DeviationLength,0,MA_Mode,UpBandPrice,shift);
      double dnStdDev = iStdDev(NULL,0,DeviationLength,0,MA_Mode,LoBandPrice,shift);
			  
      upband1[0] = upMA + Deviation*upStdDev;
      dnband1[0] = dnMA - Deviation*dnStdDev;
   
      upband2[0] = upband1[0] + 0.5*(MoneyRisk - 1)*(upband1[0] - dnband1[0]);  
      dnband2[0] = dnband1[0] - 0.5*(MoneyRisk - 1)*(upband1[0] - dnband1[0]);
	
      trend[shift] = trend[shift+1];
	
      if(Close[shift] > upband1[1]) trend[shift] = 1; 
      if(Close[shift] < dnband1[1]) trend[shift] =-1;
		  
      UpTrend[shift]  = EMPTY_VALUE;  
      DnTrend[shift]  = EMPTY_VALUE;  
      UpSignal[shift] = EMPTY_VALUE;  
      DnSignal[shift] = EMPTY_VALUE;  
      UpLine[shift]   = EMPTY_VALUE;  
      DnLine[shift]   = EMPTY_VALUE;
	   
         if(trend[shift] > 0)
         {
         if(dnband1[0] < dnband1[1]) dnband1[0] = dnband1[1];
         if(dnband2[0] < dnband2[1]) dnband2[0] = dnband2[1];
	   
         if(SignalMode != 2) UpTrend[shift] = dnband2[0];
	      if(LineMode    > 0) UpLine[shift]  = dnband2[0];   
         if(SignalMode  > 0 && trend[shift+1] < 0) UpSignal[shift] = dnband2[0];
         }      
	  
         if(trend[shift] < 0)
         {
         if(upband1[0] > upband1[1]) upband1[0] = upband1[1];
         if(upband2[0] > upband2[1]) upband2[0] = upband2[1];	  
	   
         if(SignalMode != 2) DnTrend[shift] = upband2[0];
         if(LineMode    > 0) DnLine[shift]  = upband2[0];   
         if(SignalMode  > 0 && trend[shift+1] > 0) DnSignal[shift] = upband2[0];
         }      
      }
//----
      if(AlertMode > 0)
      {
      bool uptrend = trend[1] > 0 && trend[2] <= 0;                  
      bool dntrend = trend[1] < 0 && trend[2] >= 0;
        
         if(uptrend || dntrend)
         {
            if(isNewBar(TimeFrame))
            {
            BoxAlert(uptrend," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(UpSignal[1],Digits));   
            BoxAlert(dntrend," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(DnSignal[1],Digits)); 
            }
      
         WarningSound(uptrend,SoundsNumber,SoundsPause,UpSound,Time[1]);
         WarningSound(dntrend,SoundsNumber,SoundsPause,DnSound,Time[1]);
         
            if(EmailMode > 0)
            {
            EmailAlert(uptrend,"BUY" ," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(UpSignal[1],Digits),EmailsNumber); 
            EmailAlert(dntrend,"SELL"," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss at "+DoubleToStr(DnSignal[1],Digits),EmailsNumber); 
            }
         }
      }
   }   
   
	 	         
//----	
	return(0);	
}

bool isNewBar(int tf)
{
   static datetime pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= pTime)
      {
      res=true;
      pTime=iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

bool BoxAlert(bool cond,string text)   
{      
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text;
   
   if (cond && mess != prevmess)
	{
	Alert (mess);
	prevmess = mess; 
	return(true);
	} 
  
   return(false);  
}

bool Pause(int sec)
{
   if(TimeCurrent() >= preTime + sec) {preTime = TimeCurrent(); return(true);}
   
   return(false);
}

void WarningSound(bool cond,int num,int sec,string sound,datetime ctime)
{
   static int i;
   
   if(cond)
   {
   if(ctime != ptime) i = 0; 
   if(i < num && Pause(sec)) {PlaySound(sound); ptime = ctime; i++;}       	
   }
}

bool EmailAlert(bool cond,string text1,string text2,int num)   
{      
   string subj = "New " + text1 +" Signal from " + IndicatorName + "!!!";    
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text2;
   
   if (cond && mess != prevemail)
	{
	if(subj != "" && mess != "") for(int i=0;i<num;i++) SendMail(subj, mess);  
	prevemail = mess; 
	return(true);
	} 
  
   return(false);  
}	         
 
string tf(int timeframe)
{
   switch(timeframe)
   {
   case PERIOD_M1:   return("M1");
   case PERIOD_M5:   return("M5");
   case PERIOD_M15:  return("M15");
   case PERIOD_M30:  return("M30");
   case PERIOD_H1:   return("H1");
   case PERIOD_H4:   return("H4");
   case PERIOD_D1:   return("D1");
   case PERIOD_W1:   return("W1");
   case PERIOD_MN1:  return("MN1");
   default:          return("Unknown timeframe");
   }
}                  